<template>
    <div class="text-end px-2">
        <button alt="Guardar" title="Guardar"  type="button" class="btn btn-guardar mt-1 mx-2 fs-3" @click="guardar()">
            <i class="fa-solid fa-floppy-disk "></i>
        </button>
    </div>
    <div class="d-md-flex align-items-center flex-wrap justify-content-start p-4 contenedorPrincipal mt-3">
        <div class="col-2 d-md-flex flex-column me-0 me-md-2">
            <label class="form-label ">Fecha Desde:</label>
            <input type="date" v-model="data.fecha_desde" class="form-label" id="f_desde" autocomplete="off" />
        </div>

        <div class="col-2  d-md-flex flex-column me-0 me-md-5">
            <label class="form-label ">Fecha Hasta:</label>
            <input type="date" v-model="data.fecha_hasta" class="form-label " id="f_hasta" autocomplete="off" />
        </div>

        <div class="col-2 d-md-flex flex-column  ">
            <label class="form-label ">Monto Mínimo:</label>
            <!-- <input type="number" v-model.number="data.monto_min" class="form-control" id="doc-solicitante" /> -->
            <InputCurrency class="form-label p-1 px-2" v-model="data.monto_min" :disabled="false" />
        </div>

        <div class="col-2 d-md-flex flex-column ">
            <label class="form-label ">Monto Máximo:</label>
            <!-- <input type="number" v-model.number="data.monto_max" class="form-control" id="doc-solicitante" /> -->
            <InputCurrency class="form-label p-1 px-2" v-model="data.monto_max" :disabled="false" />
        </div>

        <div class="col-5 mt-3">
            <label class="form-label">Observaciones:</label>
            <textarea v-model="data.observaciones" class="form-control" id="dependencia-solicitante"></textarea>
        </div>
    </div>
</template>

<script setup lang="ts">
//librerias
import { reactive, computed, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import http from "@/http";
import { loading, urlApi, isEmpty } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
import type { AxiosError } from "axios";
import { InputCurrency } from "@hcd-bsas/vue3-components";
//Entities
// Stores
import { useCuposStore } from "@/stores/Cupos/cupos";
import { useConfigStore } from "@/stores/configgral";
import { useTopesStore } from "@/stores/Topes/topes";
//component



const cuposStore = useCuposStore();
const configStore = useConfigStore();
const topesStore = useTopesStore();

const router = useRouter();
const route = useRoute();

var data = reactive({
    anio: "" as string,
    f_periodo: "" as string,
    fecha_desde: "" as string,
    fecha_hasta: "" as string,
    monto_min: 0 as number,
    monto_max: 0 as number,
    observaciones: "" as string,

});

const esAlta = computed(() => {
    return isEmpty(route.params.id) ? true : false;
});

class validateForm { flag: boolean = false; mensaje!: string };
function validar(): validateForm {

    if (data.fecha_desde == "" || data.fecha_hasta == "") {
        return {
            flag: false,
            mensaje: "Fechas en Blanco"
        };
    }
    //validar que fecha desde y hasta el año  sea = al periodo activo ( data.anio )
    let anio_desde = data.fecha_desde.substring(0, 4);
    let anio_hasta = data.fecha_hasta.substring(0, 4);
    if (anio_desde != data.anio || anio_hasta != data.anio) {
        return {
            flag: false,
            mensaje: "Año Diferente al Periodo Activo"
        };
    }

    if (data.fecha_desde >= data.fecha_hasta) {
        return {
            flag: false,
            mensaje: "Fecha Desde No puede Ser Superior a Fecha Hasta"
        };
    }

    if (data.monto_min <= 0 || data.monto_min == null) { //esto falta el filtro ver tmb la librery
        return {
            flag: false,
            mensaje: "Indique un Monto Minimo Superior a 0"
        };
    }

    if (data.monto_max <= 0 || data.monto_max == null) { //esto falta el filtro ver tmb la librery
        return {
            flag: false,
            mensaje: "Indique un Monto Maximo Superior a 0"
        };

    }

    if (data.monto_max < data.monto_min) { //esto falta el filtro ver tmb la librery
        return {
            flag: false,
            mensaje: "Indique un Monto Minimo Superior al maximo "
        };
    }

    return {
        flag: true,
        mensaje: ""
    };

}


async function guardar() {

    var { flag, mensaje } = validar();

    const swal_error: SweetAlertOptions<any, any> = {
        icon: "error",
        title: "Error",
        html: "",
    }
    if (esAlta.value) {
        if (flag == true) {
            loading.show();
            var rta = await http.post(urlApi + "addCupoBecario", {
                monto_min: data.monto_min,
                monto_max: data.monto_max,
                vigencia_desde: data.fecha_desde,
                vigencia_hasta: data.fecha_hasta,
                descripcion: data.observaciones,
            }).then(async () => {
                router.push({
                    name: "inicioTopesMensuales",
                });
                Swal.fire({
                    icon: "success",
                    text: "Se grabo el Tope.",
                })
                loading.hide();
            }).catch(function (error: AxiosError<string, any>) {
                if (error.response) {
                    // Request made and server responded
                    swal_error.html = error.response.data;
                    console.log("Error: request made and server responded");
                    console.log(swal_error.html);
                    console.log(error.response);
                } else if (error.request) {
                    // The request was made but no response was received
                    swal_error.html =
                        "Error desconocido. Por favor, avise al Administrador.";
                    console.log("Error: the request was made but no response was received");
                    console.log(error.request);
                } else {
                    // Something happened in setting up the request that triggered an Error
                    swal_error.html =
                        "Error desconocido. Por favor, avise al Administrador.";
                    console.log(
                        "Error: something happened in setting up the request that triggered an error"
                    );
                    console.log(error);
                }
                loading.hide();
                Swal.fire(swal_error);
            });
        } else {
            Swal.fire({
                icon: "error",
                text: mensaje,
            });
        }
    } else {
        var rta = await http.post(urlApi + "modifyCupoBecario", {
            id_becariocupo: Number(route.params.id),
            monto_min: data.monto_min,
            monto_max: data.monto_max,
            vigencia_desde: data.fecha_desde,
            vigencia_hasta: data.fecha_hasta,
            descripcion: data.observaciones,
        }).then(async () => {
            router.push({
                name: "inicioTopesMensuales",
            });
            Swal.fire({
                icon: "success",
                text: "Se Actualizo el Tope.",
            })
            loading.hide();
        }).catch(function (error: AxiosError<string, any>) {
            if (error.response) {
                // Request made and server responded
                swal_error.html = error.response.data;
                console.log("Error: request made and server responded");
                console.log(swal_error.html);
                console.log(error.response);
            } else if (error.request) {
                // The request was made but no response was received
                swal_error.html =
                    "Error desconocido. Por favor, avise al Administrador.";
                console.log("Error: the request was made but no response was received");
                console.log(error.request);
            } else {
                // Something happened in setting up the request that triggered an Error
                swal_error.html =
                    "Error desconocido. Por favor, avise al Administrador.";
                console.log(
                    "Error: something happened in setting up the request that triggered an error"
                );
                console.log(error);
            }
            loading.hide();
            Swal.fire(swal_error);
        });
    }

}

async function loadTope(id_becariocupo: number) {
    //loading.show();
    //aca cargar el tope
    var datos = await topesStore.findTopeById(id_becariocupo);
    //recargar
    if (datos == undefined) {

        await configStore.updateListadoPeriodo();
        var anio = configStore.listadoPeriodoActivo[0]?.anioActivo;

        await topesStore.updateListadoTopes({
            id_becario_cupo: null,
            fecha_desde: anio + "-03-01",
            fecha_hasta: anio + "-12-31",

        });
        var datos = await topesStore.findTopeById(id_becariocupo);
    }
    data.fecha_desde = datos!.vigencia_desde;
    data.fecha_hasta = datos!.vigencia_hasta;
    data.monto_min = parseInt(datos!.monto_min);
    data.monto_max = parseInt(datos!.monto_max);
    data.observaciones = datos!.descripcion;
    loading.hide();
}


onMounted(async () => {

    loading.show();

    await configStore.updateListadoPeriodo();
    data.anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
    data.f_periodo = configStore.listadoPeriodoActivo[0]?.f_periodo;
    data.fecha_desde = data.anio + "-03-01";
    data.fecha_hasta = data.anio + "-12-31";

    await cuposStore.updateListadoCargos();
    if (!esAlta.value) {
        await loadTope(Number(route.params.id));
    } else { loading.hide(); }
    //loading.hide();
});


</script>
